%%
%% MATLAB TEST FILE FOR ACTIVEX COMPONENT 
%%              CORNERTRACKER
%%

disp('READ IMAGES FROM FILE');
i1 = imread('IMAGE1.BMP'); i2 = imread('IMAGE2.BMP');

disp('GET IMAGE DIMENSION');		
imgsize = size(i1);					

disp('DEFINE THE POINTS TO TRACK FOR IMAGE1');
disp('YOU CAN USE THE CORNERDETECTOR ACTIVEX OBJECT TO DO THIS');
points_to_track = [151,122;148,103;19,198;220,87;122,118;208,89];

disp('VISUALIZE POINTS TO TRACK');
disp('THERE IS A 1 PIXEL OFFSET MATLAB COORDINATES AND IMAGE COORDINATES');
figure(1);
imshow(i1);
hold on;
plot(points_to_track(:,1)+1,points_to_track(:,2)+1,'r.');
hold off;
disp('Press any key to continue ...');
pause;
   
disp('CREATE CORNERTRACKER ACTIVEX SERVER OBJECT');
h = actxserver('CornerTracker.CoCornerTracker');

disp('CONFIGURE OBJECT COMPATIBLE WITH IMAGE SIZE');
h.lines = imgsize(1);		
h.columns = imgsize(2);		

disp('ALLOCATE ACTIVEX INTERNAL RESOURCES');
invoke(h,'create_corner_tracker');

disp('TRACK CORNERS');
disp('NOTICE THAT MATLAB REPRESENTS DATA COLUMNWISE. USE THE TRANSPOSE');	
tracked_points = invoke(h,'track_corners',i1',i2',points_to_track);

disp('VISUALIZE TRACKED CORNERS');
disp('THERE IS A 1 PIXEL OFFSET BETWEEN THE ACTIVEX OBJECT AND MATLAB COORDINATES');
figure(2);
imshow(i2);
hold on;
for i = 1:size(tracked_points,1),
    if( tracked_points(i,3) == 1 ),  %match is valid
        plot(tracked_points(i,1)+1,tracked_points(i,2)+1,'r.');
        plot([points_to_track(i,1) tracked_points(i,1)],[points_to_track(i,2) tracked_points(i,2)],'r-')
    end;    
end;    
hold off; 
disp('Press any key to continue ...');
pause;
figure(1);
pause;
figure(2);
pause;
figure(1);
pause;
figure(2);

disp('CLOSE OBJECT');
invoke(h,'destroy_corner_tracker');
delete(h);

%%
%% Copyright (c) 2001, Alexandre Bernardino - ISR/IST.  All rights reserved.
%% alex@isr.ist.utl.pt
%%

